# Generated by Django 4.0.4 on 2022-05-22 07:45

import datetime
import django.core.validators
from django.db import migrations, models
import django.db.models.deletion
import re
import uuid


class Migration(migrations.Migration):

    initial = True

    dependencies = []

    operations = [
        migrations.CreateModel(
            name="Category",
            fields=[
                (
                    "id",
                    models.UUIDField(
                        default=uuid.uuid4,
                        editable=False,
                        primary_key=True,
                        serialize=False,
                    ),
                ),
                (
                    "name",
                    models.CharField(
                        default="New Category",
                        max_length=64,
                        validators=[
                            django.core.validators.RegexValidator(
                                re.compile("^[-\\w]+\\Z"),
                                "Enter a valid “slug” consisting of Unicode letters, numbers, underscores, or hyphens.",
                                "invalid",
                            )
                        ],
                    ),
                ),
                ("icon", models.CharField(default="folder", max_length=64)),
            ],
            options={
                "ordering": ["name"],
            },
        ),
        migrations.CreateModel(
            name="Transaction",
            fields=[
                (
                    "id",
                    models.UUIDField(
                        default=uuid.uuid4,
                        editable=False,
                        primary_key=True,
                        serialize=False,
                    ),
                ),
                ("name", models.CharField(default="New Transaction", max_length=256)),
                ("description", models.TextField(blank=True, null=True)),
                (
                    "value",
                    models.DecimalField(decimal_places=2, default=0, max_digits=12),
                ),
                ("date", models.DateField(default=datetime.date.today)),
                ("trader", models.CharField(blank=True, max_length=128, null=True)),
                (
                    "category",
                    models.ForeignKey(
                        blank=True,
                        null=True,
                        on_delete=django.db.models.deletion.SET_NULL,
                        to="main.category",
                    ),
                ),
            ],
            options={
                "ordering": ["-date"],
            },
        ),
        migrations.CreateModel(
            name="Snapshot",
            fields=[
                (
                    "id",
                    models.UUIDField(
                        default=uuid.uuid4,
                        editable=False,
                        primary_key=True,
                        serialize=False,
                    ),
                ),
                ("date", models.DateField(default=datetime.date.today, unique=True)),
                (
                    "value",
                    models.DecimalField(decimal_places=2, default=0, max_digits=12),
                ),
                (
                    "diff",
                    models.DecimalField(
                        decimal_places=2, default=0, editable=False, max_digits=12
                    ),
                ),
                (
                    "previous",
                    models.OneToOneField(
                        blank=True,
                        editable=False,
                        null=True,
                        on_delete=django.db.models.deletion.SET_NULL,
                        to="main.snapshot",
                    ),
                ),
            ],
            options={
                "ordering": ["-date"],
            },
        ),
        migrations.CreateModel(
            name="Invoice",
            fields=[
                (
                    "id",
                    models.UUIDField(
                        default=uuid.uuid4,
                        editable=False,
                        primary_key=True,
                        serialize=False,
                    ),
                ),
                ("name", models.CharField(default="New Invoice", max_length=256)),
                (
                    "file",
                    models.FileField(
                        upload_to="invoices/",
                        validators=[
                            django.core.validators.FileExtensionValidator(["pdf"])
                        ],
                    ),
                ),
                (
                    "transaction",
                    models.ForeignKey(
                        on_delete=django.db.models.deletion.CASCADE,
                        to="main.transaction",
                    ),
                ),
            ],
        ),
    ]
